
public class ArrayList {

	private static final int DEFAULT_CAPACITY = 10;
	private String[] data;
	private int size;

	public ArrayList() {
		// data = new String[DEFAULT_CAPACITY];
		// size = 0;

		this(DEFAULT_CAPACITY);
	}

	public ArrayList(int capacity) {
		data = new String[capacity];
		size = 0;
	}

	public void add(String str) {

		// are we out of room?
		if (size == data.length) {
			// if we are, we need to double the size of the array
			doubleArray();
		}

		data[size] = str;
		size++;

	}

	public boolean add(int index, String str) {
		// is the index valid?
		if (index < 0 || index > size) {
			// if not, throw an exception
			throw new IndexOutOfBoundsException();
		}

		// are we out of room?
		if (size == data.length) {
			// if we are, we need to double the size of the array
			doubleArray();
		}

		// shifting elements down one index
		// adding str
		for (int i = size; i > index; i--) {
			data[i] = data[i - 1];
		}

		data[index] = str;
		size++;

		return true;
	}
	
	private void doubleArray() {
		ensureCapacity(size*2);
	}

	public void ensureCapacity(int capacity) {
		if(capacity > size) {
			String[] newData = new String[capacity];
			for(int i = 0; i < size; i++) {
				newData[i] = data[i];
			}
			
			data = newData;
		}
	}

	public void trimToSize() {
		if (data.length > size) {
			String[] newData = new String[size];
			for (int i = 0; i < newData.length; i++) {
				newData[i] = data[i];
			}

			data = newData;
		}
	}
	
	public String remove(int index) {
		if(index < 0 || index >= size) {
			throw new IndexOutOfBoundsException();
		}
		
		String toReturn = data[index];
		
		for(int i = index; i < size-1; i++) {
			data[i] = data[i+1];
		}
		size--;
		data[size] = null;
		
		return toReturn;
	}
	
	public boolean remove(String str) {
		for(int i = 0; i < size; i++) {
			if(data[i].equals(str)) {
				remove(i);
				return true;
			}
		}
		
		return false;
	}
	
}
